#pragma once
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef UINT32
	typedef unsigned __int32 UINT32;
#endif

class Hash
{
	static char LuhnD[20];
	static char VerDataD[100];
	static char VerDataP[80];

public:
	static UINT32* Ret;
	static char* Digest;

	static void  Init    ();
	static void  Clean   ();

	static int   AddHash (char* str, int size, int block, int mod);
	static int   XorHash (char* str, int size, int block);
	static char* SHA1    (char* str, int size);
	static char* SHA2    (char* str, int size);
	static char* MD5     (char* str, int size);
	static int   Adler32 (char* str, int size);
	static int   Luhn    (char* str, int size);
	static int   Verhoeff(char* str, int size);
};