#pragma once
#include "buffer.h"
#include <WinSock.h>

class Socket
{
public:
	static int           SIN_size;
	static char*         dbuff;
	static unsigned long sync;

	static void          Init ();
	static void          Clean();
	static unsigned long IP   (char* address);

	/*	0		IPv4 UDP
		1		IPv4 TCP
	*/
	int         type;

	/*
	*/
	int         options;

	SOCKADDR_IN other;
	SOCKET      id;
	Buffer*     bin;

	Socket();
	~Socket();

	int           Listen (int typ, unsigned short port);
	Socket*       Accept ();
	int           Connect(unsigned long ip, unsigned short port, int typ);

	int           Send(Buffer* b);
	int           Recv(Buffer* b);
	int           Peek(Buffer* b);

	unsigned long  GetIP();
	unsigned short GetPort();
	bool           Connected();
};
