#pragma once
#include <stdlib.h>
#include <string.h>

class Buffer
{
public:
	static char* retval;
	static int   retvalsz;
	static void  Init();
	static void  Clean();

	char* data;
	int count;
	int realsize;
	int readpos;
	int writepos;

	Buffer();
	~Buffer();

	void expand(int size);

	void write(void* src, int size);
	void read(void* dst, int size);

	void writebyte  (unsigned char a);
	void writeshort (short a);
	void writeushort(unsigned short a);
	void writeint   (int a);
	void writeuint  (unsigned int a);
	void writefloat (float a);
	void writedouble(double a);
	void writechars (char* str, int len);

	unsigned char  readbyte  ();
	short          readshort ();
	unsigned short readushort();
	int            readint   ();
	unsigned int   readuint  ();
	float          readfloat ();
	double         readdouble();
	char*          readchars (int len);
	char*          readstring();
	char*          readsep   (char* sep);

	void clear();

	void setwrite(int pos, bool rel);
	void setread(int pos, bool rel);
};
